<template>
    <div v-if="data">
        <div class="push-component-container">
            <div
                v-show="data.reminders[0]"
                class="table-responsive"
            >
                <table class="table-hover">
                    <thead class="table-header">
                        <tr>
                            <th class="reminders-text">
                                Reminders
                            </th>
                            <th>Sent</th>
                            <th>Clicked</th>
                            <th>CTR, (%)</th>
                            <th>Orders</th>
                            <th>CVR, (%)</th>
                            <th>Revenue</th>
                            <th>Cost</th>
                            <th>ROI, (%)</th>
                            <th>Active</th>
                            <th />
                        </tr>
                    </thead>
                    <tbody class="table-body">
                        <tr
                            v-for="(reminder, index) in data.reminders"
                            :key="index"
                            class="table-body-row"
                        >
                            <th>
                                <div
                                    v-if="reminder.order === 1"
                                    class="counter-text"
                                >
                                    {{ reminder.order }}st
                                </div>
                                <div
                                    v-else-if="reminder.order === 2"
                                    class="counter-text"
                                >
                                    {{ reminder.order }}nd
                                </div>
                                <div
                                    v-else-if="reminder.order === 3"
                                    class="counter-text"
                                >
                                    {{ reminder.order }}rd
                                </div>
                                <div
                                    v-else
                                    class="counter-text"
                                >
                                    {{ reminder.order }}th
                                </div>
                                <div
                                    v-if="reminder.order === 1"
                                    class="last-seen"
                                >
                                    {{ reminder.send_time }} {{ reminder.send_time_type }} after abandoned checkout
                                </div>
                                <div
                                    v-else
                                    class="last-seen"
                                >
                                    {{ reminder.send_time }} {{ reminder.send_time_type }} after previous message
                                </div>
                            </th>
                            <th>{{ reminder.sent_count }}</th>
                            <th>{{ reminder.clicked_count }}</th>
                            <th>{{ reminder.click_rate }}</th>
                            <th>{{ reminder.orders_count }}</th>
                            <th>{{ reminder.cvr }}</th>
                            <th>{{ $store.state.shop.currency || '' }}{{ $formatter.fixedNumber(reminder.revenue) }}</th>
                            <th>${{ reminder.sms_costs }}</th>
                            <th>{{ reminder.roi }} %</th>
                            <th>
                                <ToggleButton
                                    v-model="reminder.status"
                                    :font-size="12"
                                    class="toggle-btn"
                                    :height="24"
                                    :labels="true"
                                    color="rgb(45, 119, 245)"
                                    @change="changeStatus(reminder.id, reminder.status)"
                                />
                            </th>
                            <th
                                v-if="reminder.type === 'default'"
                                class="text-left"
                            >
                                <router-link
                                    :to="'/sms/abandoned-carts/reminders/' + reminder.order"
                                    class="btn light-blue-btn"
                                >
                                    Edit
                                </router-link>
                            </th>
                            <th
                                v-else
                                class="text-left"
                            >
                                <router-link
                                    :to="'/sms/abandoned-carts/reminders/' + reminder.order"
                                    class="btn light-blue-btn"
                                >
                                    Edit
                                </router-link>
                                <b-btn
                                    type="button"
                                    class="red-button"
                                    @click="deleteReminder(reminder.id)"
                                >
                                    Remove
                                </b-btn>
                            </th>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</template>

<script>
import smsReminder from '../../mixins/sms/abandoned-carts.service'

export default {
    name: "SmsAbandonedTable",
    mixins: [smsReminder],
    props: {
        data: {
            order: {
                type: String,
                default: "0"
            },
            sent_count: {
                type: String,
                default: "0"
            },
            clicked_count: {
                type: String,
                default: "0"
            },
            click_rate: {
                type: String,
                default: "0"
            },
            orders_count: {
                type: String,
                default: "0"
            },
            cvr: {
                type: String,
                default: "0"
            },
            revenue: {
                type: String,
                default: "0"
            },
        }
    },
    methods: {
        changeStatus(id, status) {
            this.status(id, status).then(response => {
                this.$notify({
                    type: 'success',
                    title: 'Status Changed'
                });
            }).catch(error => {
                console.log(error)
            });
        },
        deleteReminder(id) {
            this.delete(id).then(response => {
                if (response) {
                    this.$notify({
                        type: 'success',
                        title: 'Deleted'
                    });
                    this.$emit('getAbandonedCarts')
                }
            })
        },
    }
}
</script>

<style scoped lang="scss">

.toggle-btn {
    margin-right: 0px;
}

</style>
